Note: Due to technical difficulties, the Archives are currently not up to date.
GMANE provides an alternative service for most mailing lists. c.f. bug 424647
List Archive: gentoo-commits
Author: zmedico
Date: 2009-01-07 23:49:08 +0000 (Wed, 07 Jan 2009)
New Revision: 12389
Modified:
main/trunk/bin/ebuild.sh
Log:
Bug #250469 - Fix unpack() so that deb2targz is called in a way such that
$DISTDIR write access is not required.
Modified: main/trunk/bin/ebuild.sh
===================================================================
--- main/trunk/bin/ebuild.sh 2009-01-07 22:37:06 UTC (rev 12388)
+++ main/trunk/bin/ebuild.sh 2009-01-07 23:49:08 UTC (rev 12389)
@@ -406,10 +406,24 @@
# that reason. We just make sure on AIX `deb2targz` is
# installed.
if type -P deb2targz > /dev/null; then
- deb2targz "${srcdir}/${x}" || die "$myfail"
- mv "${srcdir}/${x/.deb/.tar.gz}" data.tar.gz
+ y=${x##*/}
+ local created_symlink=0
+ if [ ! "$srcdir$x" -ef "$y" ] ; then
+ # deb2targz always extracts into the same directory as
+ # the source file, so create a symlink in the current
+ # working directory if necessary.
+ ln -sf "$srcdir$x" "$y" || die "$myfail"
+ created_symlink=1
+ fi
+ deb2targz "$y" || die "$myfail"
+ if [ $created_symlink = 1 ] ; then
+ # Clean up the symlink so the ebuild
+ # doesn't inadvertently install it.
+ rm -f "$y"
+ fi
+ mv -f "${y%.deb}".tar.gz data.tar.gz || die "$myfail"
else
- ar x "${srcdir}/${x}" || die "$myfail"
+ ar x "$srcdir$x" || die "$myfail"
fi
;;
lzma)
|
|